# MatNullSpaceCreate

Creates a data structure used to project vectors out of null spaces.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode PETSCMAT_DLLEXPORT MatNullSpaceCreate(MPI_Comm comm,PetscTruth has_cnst,PetscInt n,const Vec vecs[],MatNullSpace *SP)

Collective on MPI_Comm

### Input Parameters

| comm | - the MPI communicator associated with the object
| has_cnst | - PETSC_TRUE if the null space contains the constant vector; otherwise PETSC_FALSE
| n | - number of vectors (excluding constant vector) in null space
| vecs | - the vectors that span the null space (excluding the constant vector); these vectors must be orthonormal. These vectors are NOT copied, so do not change them after this call. You should free the array that you pass in.

### Output Parameter

SP -the null space context

### Users manual sections

Section 4.15 Solving Singular Systems -

### Keywords

PC, null space, create

### See Also

MatNullSpaceDestroy(), MatNullSpaceRemove(), KSPSetNullSpace(), MatNullSpace, MatNullSpaceSetFunction()

Level:advanced
Location: src/mat/interface/matnull.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages